//<script language="jscript">

function rand(n) {
	seed = (0x015a4e35 * seed) % 0x7fffffff;
	return (seed >> 16) % n;
}

var now = new Date();
var seed = now.getTime() % 0xffffffff;

function StartAction(textobject)
{
    textobject.value="(processing) " + textobject.value;
    textobject.backgroundColor="#90f090";
}

function EndAction(textobject)
{
    if(textobject.value.indexOf("(processing) ")==0) textobject.value=textobject.value.slice(13);
    textobject.backgroundColor="none";
}

function click(buttonName)
{
    eval(buttonName+"_ul").backgroundColor='#303030'; 
    eval(buttonName+"_lr").backgroundColor='white';
}

function RemovePlaylists()
{
    var allPlaylists = player.playlistCollection.getAll();
    var totalCount = allPlaylists.count;
    for (var i=0; i<totalCount; i++)
    {
        player.playlistCollection.remove(allPlaylists.item(i));    
    }
}

function AllAlbumsToPlaylists()
{
    var allAlbums = player.mediaCollection.getAttributeStringCollection("Album","audio");
    var thisAlbum;
    for (var albumCount=0; albumCount<allAlbums.count; albumCount++)
    {
	var libraryFiles = player.mediaCollection.getByAlbum(allAlbums.item(albumCount));
	var artist = libraryFiles.item(0).getItemInfo("Artist");
        var albumTitle = "Album: ";
	if(artist) albumTitle += artist + ", ";
	albumTitle += allAlbums.item(albumCount);
        if (player.playlistCollection.getByName(albumTitle).count==0)
        {
            thisAlbum = player.playlistCollection.newPlaylist(albumTitle);
            
            for (var index=0;index<libraryFiles.count;index++)
            {
                thisAlbum.appendItem(libraryFiles.item(index));
            }
         }   
    }
}

function AllArtistsToPlaylists()
{
    var allAuthors = player.mediaCollection.getAttributeStringCollection("Author","audio");
    var thisAuthor;
    for (var AuthorCount=0; AuthorCount<allAuthors.count; AuthorCount++)
    {
	var libraryFiles = player.mediaCollection.getByAuthor(allAuthors.item(AuthorCount));
	var Author = libraryFiles.item(0).getItemInfo("Author");
        var AuthorTitle = "Artist: ";
	if(Author) AuthorTitle += Author;
    if (player.playlistCollection.getByName(AuthorTitle).count==0)
        {
            thisAuthor = player.playlistCollection.newPlaylist(AuthorTitle);
            
            for (var index=0;index<libraryFiles.count;index++)
            {
                thisAuthor.appendItem(libraryFiles.item(index));
            }
         }   
    }
}

function RandomAllContentToCDs()
{

}

function AllContentToCDs()
{
    var allContent = player.mediaCollection.getAll();
    var totalCount = allContent.count;
    var trackCount = 12;    
    var albumCount = Math.ceil(totalCount/trackCount);
    var number;
    var digitCount = (albumCount.toString().length);
    var allContentIndex;
    var playlistName = "All Content (ordered): ";

    var albumPlaylist;
    for (allContentIndex=0; allContentIndex<totalCount; allContentIndex++)
    {
        if (allContentIndex%trackCount==0)
        {
            number = Math.floor(allContentIndex/trackCount).toString();
            var zeroPadCount = digitCount - number.length;
            for (var q=0;q<zeroPadCount;q++)
            {
                number = "0" + number;
            }
            try
            {
                albumPlaylist = player.playlistCollection.newPlaylist(playlistName+number);
            }
            catch(err)
            {
                while (player.playlistCollection.getByName(playlistName+number).count!=0)
                {
                    number+=".1";
                    albumPlaylist = player.playlistCollection.newPlaylist(playlistName+number);
                }   
            }
        }
        albumPlaylist.appendItem(allContent.item(allContentIndex));
    }
}

function AllContentToSizedCDs(lengthInMinutes)
{
    var discLengthInSeconds = lengthInMinutes*60;
    var allContent = player.mediaCollection.getAll();
    var totalCount = allContent.count;
    var digitCount = 5;
    var allContentIndex;
    var playlistName = "CD: ";
    var albumPlaylist;
    var currentAlbumLength=0;
    var currentAlbumNumber=0;
    var currentItem;
    var formattedNumber;
    for (allContentIndex=0; allContentIndex<allContent.count; allContentIndex++)
    {
        currentItem = allContent.item(allContentIndex);
	    currentAlbumLength += currentItem.duration;
        if ((currentAlbumLength==0) || (currentAlbumLength > discLengthInSeconds))
        {
            currentAlbumLength=currentItem.duration;
            currentAlbumNumber++;
            formattedNumber=currentAlbumNumber.toString();
            var zeroPadCount = digitCount - formattedNumber.length;
            for (var q=0;q<zeroPadCount;q++)
            {
                formattedNumber = "0" + formattedNumber;
            }
            if (player.playlistCollection.getByName(playlistName+formattedNumber).count==0)
            {
                albumPlaylist = player.playlistCollection.newPlaylist(playlistName+formattedNumber);
            }
            else
            {
                var dotIndex;
                for (dotIndex=0; player.playlistCollection.getByName(playlistName+formattedNumber+'.'+dotIndex).count!=0; dotIndex++)
                {
                    // no op
                }   
                
                albumPlaylist = player.playlistCollection.newPlaylist(playlistName+formattedNumber+'.'+dotIndex);
            }
        }
        else
        {
            currentAlbumLength += currentItem.duration;
        }
        albumPlaylist.appendItem(currentItem);
    }
}

function RandomPlaylistToSizedCDs(playlist,lengthInMinutes)
{
    var discLengthInSeconds = lengthInMinutes*60;
    var allContent = playlist;
    var totalCount = allContent.count;
    var digitCount = 5;
    var allContentIndex;
    var playlistName = "CD: ";
    var albumPlaylist;
    var currentAlbumLength=0;
    var currentAlbumNumber=0;
    var currentItem;
    var formattedNumber;
    while (allContent.count!=0)
    {
	    allContentIndex=rand(allContent.count);
        currentItem = allContent.item(allContentIndex);
	    allContent.removeItem(currentItem);
        if ((currentAlbumLength==0) || (currentAlbumLength > discLengthInSeconds))
        {
            currentAlbumLength=currentItem.duration;
            currentAlbumNumber++;
            formattedNumber=currentAlbumNumber.toString();
            var zeroPadCount = digitCount - formattedNumber.length;
            for (var q=0;q<zeroPadCount;q++)
            {
                formattedNumber = "0" + formattedNumber;
            }
            if (player.playlistCollection.getByName(playlistName+formattedNumber).count==0)
            {
                albumPlaylist = player.playlistCollection.newPlaylist(playlistName+formattedNumber);
            }
            else
            {
                var dotIndex;
                for (dotIndex=0; player.playlistCollection.getByName(playlistName+formattedNumber+'.'+dotIndex).count!=0; dotIndex++)
                {
                    // no op
                }   
                
                albumPlaylist = player.playlistCollection.newPlaylist(playlistName+formattedNumber+'.'+dotIndex);
            }
        }
        else
        {
            currentAlbumLength += currentItem.duration;
        }
        albumPlaylist.appendItem(currentItem);
    }
}

//</script>